diff --git a/sim/common/ChangeLog b/sim/common/ChangeLog
index 80fc164..b740a17 100644
--- a/sim/common/ChangeLog
+++ b/sim/common/ChangeLog
@@ -1,5 +1,10 @@
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
 
+	* sim-module.c [WITH_WATCHPOINTS] (modules): Always call
+	sim_watchpoint_install.
+
+2015-12-24  Mike Frysinger  <vapier@gentoo.org>
+
 	* sim-base.h [SIM_HAVE_FLATMEM] (sim_state_base): Delete flatmem code.
 	* sim-module.c [SIM_HAVE_FLATMEM] (modules): Always call
 	sim_memopt_install.
diff --git a/sim/common/sim-module.c b/sim/common/sim-module.c
index afadb07..8498f80 100644
--- a/sim/common/sim-module.c
+++ b/sim/common/sim-module.c
@@ -54,9 +54,7 @@ static MODULE_INSTALL_FN * const modules[] = {
 #endif
   sim_core_install,
   sim_memopt_install,
-#if WITH_WATCHPOINTS
   sim_watchpoint_install,
-#endif
 #if WITH_SCACHE
   scache_install,
 #endif
diff --git a/sim/frv/ChangeLog b/sim/frv/ChangeLog
index 3ce4963..329d6fc 100644
--- a/sim/frv/ChangeLog
+++ b/sim/frv/ChangeLog
@@ -1,5 +1,9 @@
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
 
+	* tconfig.h (WITH_WATCHPOINTS): Delete.
+
+2015-12-24  Mike Frysinger  <vapier@gentoo.org>
+
 	* tconfig.h (SIM_HAVE_MEM_SIZE): Delete.
 
 2015-11-15  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/frv/tconfig.h b/sim/frv/tconfig.h
index 370cacc..06ec4a0 100644
--- a/sim/frv/tconfig.h
+++ b/sim/frv/tconfig.h
@@ -6,11 +6,6 @@
 /* For MSPR support.  FIXME: revisit.  */
 #define WITH_DEVICES 1
 
-#if 0
-/* Enable watchpoints.  */
-#define WITH_WATCHPOINTS 1
-#endif
-
 /* ??? Temporary hack until model support unified.  */
 #define SIM_HAVE_MODEL
 
diff --git a/sim/iq2000/ChangeLog b/sim/iq2000/ChangeLog
index df477d2..7a2aeb9 100644
--- a/sim/iq2000/ChangeLog
+++ b/sim/iq2000/ChangeLog
@@ -1,5 +1,9 @@
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
 
+	* tconfig.h (WITH_WATCHPOINTS): Delete.
+
+2015-12-24  Mike Frysinger  <vapier@gentoo.org>
+
 	* tconfig.h (SIM_HAVE_MEM_SIZE): Delete.
 
 2015-11-15  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/iq2000/tconfig.h b/sim/iq2000/tconfig.h
index 4e4978d..f8635fd 100644
--- a/sim/iq2000/tconfig.h
+++ b/sim/iq2000/tconfig.h
@@ -6,11 +6,6 @@
 /* For MSPR support.  FIXME: revisit.  */
 #define WITH_DEVICES 0
 
-#if 0
-/* Enable watchpoints.  */
-#define WITH_WATCHPOINTS 1
-#endif
-
 /* ??? Temporary hack until model support unified.  */
 #define SIM_HAVE_MODEL
 
diff --git a/sim/m32r/ChangeLog b/sim/m32r/ChangeLog
index ac2efcb..cd821a3 100644
--- a/sim/m32r/ChangeLog
+++ b/sim/m32r/ChangeLog
@@ -1,5 +1,9 @@
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
 
+	* tconfig.h (WITH_WATCHPOINTS): Delete.
+
+2015-12-24  Mike Frysinger  <vapier@gentoo.org>
+
 	* tconfig.h (SIM_HAVE_MEM_SIZE): Delete.
 
 2015-11-15  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/m32r/tconfig.h b/sim/m32r/tconfig.h
index e06d2cf..00ca73f 100644
--- a/sim/m32r/tconfig.h
+++ b/sim/m32r/tconfig.h
@@ -9,11 +9,6 @@
 /* For MSPR support.  FIXME: revisit.  */
 #define WITH_DEVICES 1
 
-#if 0
-/* Enable watchpoints.  */
-#define WITH_WATCHPOINTS 1
-#endif
-
 /* Define this to enable the intrinsic breakpoint mechanism. */
 /* FIXME: may be able to remove SIM_HAVE_BREAKPOINT since it essentially
    duplicates ifdef SIM_BREAKPOINT (right?) */
diff --git a/sim/m68hc11/ChangeLog b/sim/m68hc11/ChangeLog
index 8e2d1a5..7ba16fa 100644
--- a/sim/m68hc11/ChangeLog
+++ b/sim/m68hc11/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-24  Mike Frysinger  <vapier@gentoo.org>
+
+	* sim-main.h (WITH_WATCHPOINTS): Delete.
+
 2015-11-17  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-main.h (WITH_MODULO_MEMORY): Delete.
diff --git a/sim/m68hc11/sim-main.h b/sim/m68hc11/sim-main.h
index be33b48..144095a 100644
--- a/sim/m68hc11/sim-main.h
+++ b/sim/m68hc11/sim-main.h
@@ -20,7 +20,6 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 #ifndef _SIM_MAIN_H
 #define _SIM_MAIN_H
 
-#define WITH_WATCHPOINTS 1
 #define SIM_HANDLES_LMA 1
 
 #include "sim-basics.h"
diff --git a/sim/mips/ChangeLog b/sim/mips/ChangeLog
index 34ab06d..93c1814 100644
--- a/sim/mips/ChangeLog
+++ b/sim/mips/ChangeLog
@@ -1,5 +1,9 @@
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
 
+	* sim-main.h (WITH_WATCHPOINTS): Delete.
+
+2015-12-24  Mike Frysinger  <vapier@gentoo.org>
+
 	* interp.c [SIM_HAVE_FLATMEM] (sim_open): Delete flatmem code.
 
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/mips/sim-main.h b/sim/mips/sim-main.h
index bb64dcb..b1045a0 100644
--- a/sim/mips/sim-main.h
+++ b/sim/mips/sim-main.h
@@ -20,10 +20,6 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 #ifndef SIM_MAIN_H
 #define SIM_MAIN_H
 
-/* hobble some common features for moment */
-#define WITH_WATCHPOINTS 1
-
-
 #define SIM_CORE_SIGNAL(SD,CPU,CIA,MAP,NR_BYTES,ADDR,TRANSFER,ERROR) \
 mips_core_signal ((SD), (CPU), (CIA), (MAP), (NR_BYTES), (ADDR), (TRANSFER), (ERROR))
 
diff --git a/sim/mn10300/ChangeLog b/sim/mn10300/ChangeLog
index 920625e..0034efc 100644
--- a/sim/mn10300/ChangeLog
+++ b/sim/mn10300/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-24  Mike Frysinger  <vapier@gentoo.org>
+
+	* sim-main.h (WITH_WATCHPOINTS): Delete.
+
 2015-11-21  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (mn10300_callback): Delete.
diff --git a/sim/mn10300/sim-main.h b/sim/mn10300/sim-main.h
index 2b06de0..b489ad0 100644
--- a/sim/mn10300/sim-main.h
+++ b/sim/mn10300/sim-main.h
@@ -22,7 +22,6 @@
 #ifndef SIM_MAIN_H
 #define SIM_MAIN_H
 
-#define WITH_WATCHPOINTS 1
 #define SIM_HANDLES_LMA 1
 
 #define SIM_ENGINE_HALT_HOOK(SD,LAST_CPU,CIA) 0 /* disable this hook */
@@ -41,8 +40,6 @@
 #include "itable.h"
 #include "idecode.h"
 
-#define WITH_WATCHPOINTS 1
-
 #define SIM_CORE_SIGNAL(SD,CPU,CIA,MAP,NR_BYTES,ADDR,TRANSFER,ERROR)  \
 mn10300_core_signal ((SD), (CPU), (CIA), (MAP), (NR_BYTES), (ADDR), (TRANSFER), (ERROR))
 
diff --git a/sim/sh64/ChangeLog b/sim/sh64/ChangeLog
index f4c6aa4..c56cd98 100644
--- a/sim/sh64/ChangeLog
+++ b/sim/sh64/ChangeLog
@@ -1,5 +1,9 @@
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
 
+	* tconfig.h (WITH_WATCHPOINTS): Delete.
+
+2015-12-24  Mike Frysinger  <vapier@gentoo.org>
+
 	* tconfig.h (SIM_HAVE_MEM_SIZE): Delete.
 
 2015-11-15  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/sh64/tconfig.h b/sim/sh64/tconfig.h
index 4b700ae..6f8d7ff 100644
--- a/sim/sh64/tconfig.h
+++ b/sim/sh64/tconfig.h
@@ -6,11 +6,6 @@
 /* For MSPR support.  FIXME: revisit.  */
 #define WITH_DEVICES 0
 
-#if 0
-/* Enable watchpoints.  */
-#define WITH_WATCHPOINTS 1
-#endif
-
 /* ??? Temporary hack until model support unified.  */
 #define SIM_HAVE_MODEL
 
diff --git a/sim/v850/ChangeLog b/sim/v850/ChangeLog
index 9b23e42..82652f0 100644
--- a/sim/v850/ChangeLog
+++ b/sim/v850/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-24  Mike Frysinger  <vapier@gentoo.org>
+
+	* sim-main.h (WITH_WATCHPOINTS): Delete.
+
 2015-12-15  Dominik Vogt  <vogt@linux.vnet.ibm.com>
 
 	* simops.c (v850_bins): Fix left shift of negative value.
diff --git a/sim/v850/sim-main.h b/sim/v850/sim-main.h
index 23b23cb..e7276a6 100644
--- a/sim/v850/sim-main.h
+++ b/sim/v850/sim-main.h
@@ -1,11 +1,6 @@
 #ifndef SIM_MAIN_H
 #define SIM_MAIN_H
 
-/* General config options */
-
-#define WITH_WATCHPOINTS 1
-
-
 /* The v850 has 32bit words, numbered 31 (MSB) to 0 (LSB) */
 
 #define WITH_TARGET_WORD_MSB 31