diff --git a/sim/cris/ChangeLog b/sim/cris/ChangeLog
index dbc2d09..416db96 100644
--- a/sim/cris/ChangeLog
+++ b/sim/cris/ChangeLog
@@ -1,5 +1,10 @@
 2015-12-25  Mike Frysinger  <vapier@gentoo.org>
 
+	* sim-main.h (WITH_SCACHE_PBB): Move from ...
+	* tconfig.h (WITH_SCACHE_PBB): ... here.
+
+2015-12-25  Mike Frysinger  <vapier@gentoo.org>
+
 	* devices.c (device_error): Delete.
 
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/cris/sim-main.h b/sim/cris/sim-main.h
index 4dc04a2..ac91e67 100644
--- a/sim/cris/sim-main.h
+++ b/sim/cris/sim-main.h
@@ -24,6 +24,11 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 #ifndef SIM_MAIN_H
 #define SIM_MAIN_H
 
+/* This is a global setting.  Different cpu families can't mix-n-match -scache
+   and -pbb.  However some cpu families may use -simple while others use
+   one of -scache/-pbb.  */
+#define WITH_SCACHE_PBB 1
+
 #include "symcat.h"
 #include "sim-basics.h"
 #include "cgen-types.h"
diff --git a/sim/cris/tconfig.h b/sim/cris/tconfig.h
index 77b000f..05d8623 100644
--- a/sim/cris/tconfig.h
+++ b/sim/cris/tconfig.h
@@ -29,9 +29,4 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #define SIM_HAVE_MODEL
 
-/* This is a global setting.  Different cpu families can't mix-n-match -scache
-   and -pbb.  However some cpu families may use -simple while others use
-   one of -scache/-pbb.  */
-#define WITH_SCACHE_PBB 1
-
 #endif /* CRIS_TCONFIG_H */
diff --git a/sim/frv/ChangeLog b/sim/frv/ChangeLog
index c7a601e..08c6d98 100644
--- a/sim/frv/ChangeLog
+++ b/sim/frv/ChangeLog
@@ -1,5 +1,10 @@
 2015-12-25  Mike Frysinger  <vapier@gentoo.org>
 
+	* sim-main.h (WITH_SCACHE_PBB): Move from ...
+	* tconfig.h (WITH_SCACHE_PBB): ... here.
+
+2015-12-25  Mike Frysinger  <vapier@gentoo.org>
+
 	* devices.c (device_error): Delete.
 
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/frv/sim-main.h b/sim/frv/sim-main.h
index ef14d64..ed5d4e2 100644
--- a/sim/frv/sim-main.h
+++ b/sim/frv/sim-main.h
@@ -23,6 +23,11 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
    sim-basics.h and cgen-types.h needs config.h.  */
 #include "config.h"
 
+/* This is a global setting.  Different cpu families can't mix-n-match -scache
+   and -pbb.  However some cpu families may use -simple while others use
+   one of -scache/-pbb. ???? */
+#define WITH_SCACHE_PBB 0
+
 #include "symcat.h"
 #include "sim-basics.h"
 #include "cgen-types.h"
diff --git a/sim/frv/tconfig.h b/sim/frv/tconfig.h
index 044cfb0..1abdc61 100644
--- a/sim/frv/tconfig.h
+++ b/sim/frv/tconfig.h
@@ -5,8 +5,3 @@
 
 /* ??? Temporary hack until model support unified.  */
 #define SIM_HAVE_MODEL
-
-/* This is a global setting.  Different cpu families can't mix-n-match -scache
-   and -pbb.  However some cpu families may use -simple while others use
-   one of -scache/-pbb. ???? */
-#define WITH_SCACHE_PBB 0
diff --git a/sim/iq2000/ChangeLog b/sim/iq2000/ChangeLog
index 770a2be..45f31d5 100644
--- a/sim/iq2000/ChangeLog
+++ b/sim/iq2000/ChangeLog
@@ -1,3 +1,8 @@
+2015-12-25  Mike Frysinger  <vapier@gentoo.org>
+
+	* sim-main.h (WITH_SCACHE_PBB): Move from ...
+	* tconfig.h (WITH_SCACHE_PBB): ... here.
+
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
 
 	* tconfig.h (SIM_HANDLES_LMA): Delete.
diff --git a/sim/iq2000/sim-main.h b/sim/iq2000/sim-main.h
index 992520a..810e4f4 100644
--- a/sim/iq2000/sim-main.h
+++ b/sim/iq2000/sim-main.h
@@ -8,6 +8,11 @@
    sim-basics.h and cgen-types.h needs config.h.  */
 #include "config.h"
 
+/* This is a global setting.  Different cpu families can't mix-n-match -scache
+   and -pbb.  However some cpu families may use -simple while others use
+   one of -scache/-pbb. ???? */
+#define WITH_SCACHE_PBB 1
+
 #include "symcat.h"
 #include "sim-basics.h"
 #include "cgen-types.h"
diff --git a/sim/iq2000/tconfig.h b/sim/iq2000/tconfig.h
index bd5a3ae..cf63d44 100644
--- a/sim/iq2000/tconfig.h
+++ b/sim/iq2000/tconfig.h
@@ -5,8 +5,3 @@
 
 /* ??? Temporary hack until model support unified.  */
 #define SIM_HAVE_MODEL
-
-/* This is a global setting.  Different cpu families can't mix-n-match -scache
-   and -pbb.  However some cpu families may use -simple while others use
-   one of -scache/-pbb. ???? */
-#define WITH_SCACHE_PBB 1
diff --git a/sim/lm32/ChangeLog b/sim/lm32/ChangeLog
index 93e7d98..62320b3 100644
--- a/sim/lm32/ChangeLog
+++ b/sim/lm32/ChangeLog
@@ -1,3 +1,8 @@
+2015-12-25  Mike Frysinger  <vapier@gentoo.org>
+
+	* sim-main.h (WITH_SCACHE_PBB): Move from ...
+	* tconfig.h (WITH_SCACHE_PBB): ... here.  Delete file.
+
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
 
 	* tconfig.h (SIM_HANDLES_LMA): Delete.
diff --git a/sim/lm32/sim-main.h b/sim/lm32/sim-main.h
index 4894e8d..13d00cb 100644
--- a/sim/lm32/sim-main.h
+++ b/sim/lm32/sim-main.h
@@ -23,6 +23,8 @@
 #ifndef SIM_MAIN_H
 #define SIM_MAIN_H
 
+#define WITH_SCACHE_PBB 1
+
 #include "symcat.h"
 #include "sim-basics.h"
 #include "cgen-types.h"
diff --git a/sim/lm32/tconfig.h b/sim/lm32/tconfig.h
deleted file mode 100644
index 7db04f9..0000000
--- a/sim/lm32/tconfig.h
+++ /dev/null
@@ -1,24 +0,0 @@
-/* Lattice Mico32 simulator configuration.
-   Contributed by Jon Beniston <jon@beniston.com>
-
-   This file is part of GDB.
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 3 of the License, or
-   (at your option) any later version.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
-
-#ifndef LM32_TCONFIG_H
-#define LM32_TCONFIG_H
-
-#define WITH_SCACHE_PBB 1
-
-#endif /* LM32_TCONFIG_H */
diff --git a/sim/m32r/ChangeLog b/sim/m32r/ChangeLog
index 7a33412..f000743 100644
--- a/sim/m32r/ChangeLog
+++ b/sim/m32r/ChangeLog
@@ -1,5 +1,10 @@
 2015-12-25  Mike Frysinger  <vapier@gentoo.org>
 
+	* sim-main.h (WITH_SCACHE_PBB): Move from ...
+	* tconfig.h (WITH_SCACHE_PBB): ... here.
+
+2015-12-25  Mike Frysinger  <vapier@gentoo.org>
+
 	* devices.c (device_error): Delete.
 
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/m32r/sim-main.h b/sim/m32r/sim-main.h
index cd39e98..5b24ce8 100644
--- a/sim/m32r/sim-main.h
+++ b/sim/m32r/sim-main.h
@@ -3,6 +3,11 @@
 #ifndef SIM_MAIN_H
 #define SIM_MAIN_H
 
+/* This is a global setting.  Different cpu families can't mix-n-match -scache
+   and -pbb.  However some cpu families may use -simple while others use
+   one of -scache/-pbb.  */
+#define WITH_SCACHE_PBB 1
+
 #include "symcat.h"
 #include "sim-basics.h"
 #include "cgen-types.h"
diff --git a/sim/m32r/tconfig.h b/sim/m32r/tconfig.h
index 0a43607..42c538c 100644
--- a/sim/m32r/tconfig.h
+++ b/sim/m32r/tconfig.h
@@ -6,9 +6,4 @@
 /* For MSPR support.  FIXME: revisit.  */
 #define WITH_DEVICES 1
 
-/* This is a global setting.  Different cpu families can't mix-n-match -scache
-   and -pbb.  However some cpu families may use -simple while others use
-   one of -scache/-pbb.  */
-#define WITH_SCACHE_PBB 1
-
 #endif /* M32R_TCONFIG_H */
diff --git a/sim/sh64/ChangeLog b/sim/sh64/ChangeLog
index 92fcf75..95e792d 100644
--- a/sim/sh64/ChangeLog
+++ b/sim/sh64/ChangeLog
@@ -1,3 +1,8 @@
+2015-12-25  Mike Frysinger  <vapier@gentoo.org>
+
+	* sim-main.h (WITH_SCACHE_PBB): Move from ...
+	* tconfig.h (WITH_SCACHE_PBB): ... here.
+
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
 
 	* tconfig.h (SIM_HANDLES_LMA): Delete.
diff --git a/sim/sh64/sim-main.h b/sim/sh64/sim-main.h
index 7b24ab0..da8f516 100644
--- a/sim/sh64/sim-main.h
+++ b/sim/sh64/sim-main.h
@@ -7,6 +7,11 @@
    sim-basics.h and cgen-types.h needs config.h.  */
 #include "config.h"
 
+/* This is a global setting.  Different cpu families can't mix-n-match -scache
+   and -pbb.  However some cpu families may use -simple while others use
+   one of -scache/-pbb. ???? */
+#define WITH_SCACHE_PBB 1
+
 #include "symcat.h"
 #include "sim-basics.h"
 #include "cgen-types.h"
diff --git a/sim/sh64/tconfig.h b/sim/sh64/tconfig.h
index 4f4d9b7..b4e256f 100644
--- a/sim/sh64/tconfig.h
+++ b/sim/sh64/tconfig.h
@@ -5,8 +5,3 @@
 
 /* ??? Temporary hack until model support unified.  */
 #define SIM_HAVE_MODEL
-
-/* This is a global setting.  Different cpu families can't mix-n-match -scache
-   and -pbb.  However some cpu families may use -simple while others use
-   one of -scache/-pbb. ???? */
-#define WITH_SCACHE_PBB 1