diff --git a/sim/ChangeLog b/sim/ChangeLog
index 19327de..0e25046 100644
--- a/sim/ChangeLog
+++ b/sim/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* README-HACKING: Delete mention of tconfig.h.
+
 2015-11-24  Nick Clifton  <nickc@redhat.com>
 
 	* configure.tgt: Add aarch64 entry.
diff --git a/sim/README-HACKING b/sim/README-HACKING
index 188ca3c..26dbde2 100644
--- a/sim/README-HACKING
+++ b/sim/README-HACKING
@@ -7,7 +7,6 @@ Contents
 - Common Makefile Support
 - TAGS support
 - Generating "configure" files
-- tconfig.h
 - C Language Assumptions
 - "dump" commands under gdb
 
@@ -159,16 +158,6 @@ To add the entries to an alternative ChangeLog file, use:
 	$  make ChangeLog=MyChangeLog ....
 
 
-tconfig.h
-==========
-
-File tconfig.h defines one or more target configuration macros
-(e.g. a tm.h file).  There are very few that need defining.
-For a list of all of them, see common/tconfig.h.
-It contains them all, commented out.
-The intent is that a new port can just copy this file and
-define the ones it needs.
-
 C Language Assumptions
 ======================
 
diff --git a/sim/aarch64/ChangeLog b/sim/aarch64/ChangeLog
index cd0cd41..13e026b 100644
--- a/sim/aarch64/ChangeLog
+++ b/sim/aarch64/ChangeLog
@@ -1,5 +1,9 @@
 2015-12-26  Mike Frysinger  <vapier@gentoo.org>
 
+	* config.in, configure: Regenerate.
+
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
 	* interp.c (sim_create_inferior): Update comment and argv check.
 
 2015-12-14  Nick Clifton  <nickc@redhat.com>
diff --git a/sim/aarch64/config.in b/sim/aarch64/config.in
index 3152bea..fc7af77 100644
diff --git a/sim/aarch64/configure b/sim/aarch64/configure
index 5f078bf..d909324 100755
diff --git a/sim/arm/ChangeLog b/sim/arm/ChangeLog
index d60ac4b..950a307 100644
--- a/sim/arm/ChangeLog
+++ b/sim/arm/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-12-25  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_OBJS): Delete bag.o.
diff --git a/sim/arm/config.in b/sim/arm/config.in
index 3152bea..fc7af77 100644
diff --git a/sim/arm/configure b/sim/arm/configure
index 215f0c4..d46ffcb 100755
diff --git a/sim/avr/ChangeLog b/sim/avr/ChangeLog
index 6bc7b7d..62bf5b2 100644
--- a/sim/avr/ChangeLog
+++ b/sim/avr/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-12-15  Dominik Vogt  <vogt@linux.vnet.ibm.com>
 
 	* interp.c (sign_ext): Fix left shift of negative value.
diff --git a/sim/avr/config.in b/sim/avr/config.in
index 3152bea..fc7af77 100644
diff --git a/sim/avr/configure b/sim/avr/configure
index b9530e2..fded283 100755
diff --git a/sim/bfin/ChangeLog b/sim/bfin/ChangeLog
index 2bdfc6e..4cdc81c 100644
--- a/sim/bfin/ChangeLog
+++ b/sim/bfin/ChangeLog
@@ -1,5 +1,9 @@
 2015-12-26  Mike Frysinger  <vapier@gentoo.org>
 
+	* config.in, configure: Regenerate.
+
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
 	* devices.c (bfin_mmr_invalid): Delete cpu arg and add missing arg.
 	Add cpu, rw, and reason local vars.  Rewrite error messages.  Add
 	more todo comments.
diff --git a/sim/bfin/config.in b/sim/bfin/config.in
index 6b995a7..c5223be 100644
diff --git a/sim/bfin/configure b/sim/bfin/configure
index 76cbc6a..8edee25 100755
diff --git a/sim/common/ChangeLog b/sim/common/ChangeLog
index 05cdda8..9d15f64 100644
--- a/sim/common/ChangeLog
+++ b/sim/common/ChangeLog
@@ -1,5 +1,24 @@
 2015-12-26  Mike Frysinger  <vapier@gentoo.org>
 
+	* acinclude.m4 (AH_BOTTOM): Delete tconfig.h appending.
+	* config.in, configure: Regenerate.
+	* Make-common.in (sim-basics_h): Delete tconfig.h.
+	(distclean): Likewise.
+	* sim-core.c (device_io_read_buffer, device_io_write_buffer): Delete.
+	(new_sim_core_mapping): Delete WITH_HW and device *device.
+	(sim_core_map_attach, sim_core_attach): Likewise.
+	(sim_core_read_buffer): Delete WITH_DEVICES logic.
+	(sim_core_write_buffer): Likewise.
+	* sim-core.h (struct _sim_core_mapping): Delete WITH_HW and device
+	*device.
+	(sim_core_attach): Likewise.
+	(device_io_read_buffer, device_io_write_buffer): Delete.
+	* sim-n-core.h (sim_core_read_aligned_N): Delete WITH_DEVICES logic.
+	(sim_core_write_aligned_N): Likewise.
+	* tconfig.h: Delete file.
+
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
 	* sim-core.c (sim_core_read_buffer): Move cia decl to top of func.
 	Call sim_cpu_hw_io_read_buffer if cpu is valid.
 	(sim_core_write_buffer): Move cia decl to top of func.  Call
diff --git a/sim/common/Make-common.in b/sim/common/Make-common.in
index 2566bf4..d2a84d4 100644
--- a/sim/common/Make-common.in
+++ b/sim/common/Make-common.in
@@ -361,7 +361,6 @@ sim-base_h = $(srccom)/sim-base.h \
 		$(sim-cpu_h)
 sim-basics_h = $(srccom)/sim-basics.h \
 		../common/cconfig.h \
-		tconfig.h \
 		$(sim-config_h) \
 		$(callback_h) \
 		$(sim-inline_h) \
@@ -536,7 +535,7 @@ clean: $(SIM_EXTRA_CLEAN)
 distclean mostlyclean maintainer-clean realclean: clean $(SIM_EXTRA_DISTCLEAN)
 	rm -f TAGS
 	rm -f Makefile config.cache config.log config.status .gdbinit
-	rm -f tconfig.h config.h stamp-h
+	rm -f config.h stamp-h
 	rm -f targ-vals.def
 
 .c.o:
diff --git a/sim/common/acinclude.m4 b/sim/common/acinclude.m4
index 672227e..ebb6d1b 100644
--- a/sim/common/acinclude.m4
+++ b/sim/common/acinclude.m4
@@ -53,9 +53,6 @@ AR=${AR-ar}
 AC_SUBST(AR)
 AC_PROG_RANLIB
 
-dnl Pull in the target configuration file directly.
-AH_BOTTOM([#include "tconfig.h"])
-
 # Some of the common include files depend on bfd.h, and bfd.h checks
 # that config.h is included first by testing that the PACKAGE macro
 # is defined.
diff --git a/sim/common/config.in b/sim/common/config.in
index 1904046..4f3c89f 100644
diff --git a/sim/common/configure b/sim/common/configure
index 7f1ef52..d58935d 100755
diff --git a/sim/common/sim-core.c b/sim/common/sim-core.c
index 68212e9..eb4cbb2 100644
--- a/sim/common/sim-core.c
+++ b/sim/common/sim-core.c
@@ -28,8 +28,6 @@
 
 #if (WITH_HW)
 #include "sim-hw.h"
-#define device_io_read_buffer(client, ...) device_io_read_buffer ((device *)(client), __VA_ARGS__)
-#define device_io_write_buffer(client, ...) device_io_write_buffer ((device *)(client), __VA_ARGS__)
 #endif
 
 /* "core" module install handler.
@@ -141,11 +139,7 @@ new_sim_core_mapping (SIM_DESC sd,
 		      address_word addr,
 		      address_word nr_bytes,
 		      unsigned modulo,
-#if WITH_HW
 		      struct hw *device,
-#else
-		      device *device,
-#endif
 		      void *buffer,
 		      void *free_buffer)
 {
@@ -174,11 +168,7 @@ sim_core_map_attach (SIM_DESC sd,
 		     address_word addr,
 		     address_word nr_bytes,
 		     unsigned modulo,
-#if WITH_HW
 		     struct hw *client, /*callback/default*/
-#else
-		     device *client, /*callback/default*/
-#endif
 		     void *buffer, /*raw_memory*/
 		     void *free_buffer) /*raw_memory*/
 {
@@ -264,11 +254,7 @@ sim_core_attach (SIM_DESC sd,
 		 address_word addr,
 		 address_word nr_bytes,
 		 unsigned modulo,
-#if WITH_HW
 		 struct hw *client,
-#else
-		 device *client,
-#endif
 		 void *optional_buffer)
 {
   sim_core *memory = STATE_CORE (sd);
@@ -485,26 +471,6 @@ sim_core_read_buffer (SIM_DESC sd,
 			    0 /*dont-abort*/, NULL, NULL_CIA);
     if (mapping == NULL)
       break;
-#if (WITH_DEVICES)
-    if (mapping->device != NULL)
-      {
-	int nr_bytes = len - count;
-	sim_cia cia = cpu ? CPU_PC_GET (cpu) : NULL_CIA;
-	if (raddr + nr_bytes - 1> mapping->bound)
-	  nr_bytes = mapping->bound - raddr + 1;
-	if (device_io_read_buffer (mapping->device,
-				   (unsigned_1*)buffer + count,
-				   mapping->space,
-				   raddr,
-				   nr_bytes,
-				   sd,
-				   cpu,
-				   cia) != nr_bytes)
-	  break;
-	count += nr_bytes;
-	continue;
-      }
-#endif
 #if (WITH_HW)
     if (mapping->device != NULL)
       {
@@ -563,26 +529,6 @@ sim_core_write_buffer (SIM_DESC sd,
 			       0 /*dont-abort*/, NULL, NULL_CIA);
       if (mapping == NULL)
 	break;
-#if (WITH_DEVICES)
-      if (mapping->device != NULL)
-	{
-	  int nr_bytes = len - count;
-	  sim_cia cia = cpu ? CPU_PC_GET (cpu) : NULL_CIA;
-	  if (raddr + nr_bytes - 1 > mapping->bound)
-	    nr_bytes = mapping->bound - raddr + 1;
-	  if (device_io_write_buffer (mapping->device,
-				      (unsigned_1*)buffer + count,
-				      mapping->space,
-				      raddr,
-				      nr_bytes,
-				      sd,
-				      cpu,
-				      cia) != nr_bytes)
-	    break;
-	  count += nr_bytes;
-	  continue;
-	}
-#endif
 #if (WITH_HW)
       if (mapping->device != NULL)
 	{
diff --git a/sim/common/sim-core.h b/sim/common/sim-core.h
index bf98232..6fdf120 100644
--- a/sim/common/sim-core.h
+++ b/sim/common/sim-core.h
@@ -57,11 +57,7 @@ struct _sim_core_mapping {
   void *free_buffer;
   void *buffer;
   /* callback map */
-#if (WITH_HW)
   struct hw *device;
-#else
-  device *device;
-#endif
   /* tracing */
   int trace;
   /* growth */
@@ -144,11 +140,7 @@ extern void sim_core_attach
  address_word addr,
  address_word nr_bytes,
  unsigned modulo,
-#if (WITH_HW)
  struct hw *client,
-#else
- device *client,
-#endif
  void *optional_buffer);
 
 
@@ -347,13 +339,4 @@ DECLARE_SIM_CORE_READ_N(misaligned,7,8)
 
 #undef DECLARE_SIM_CORE_READ_N
 
-
-#if (WITH_DEVICES)
-/* TODO: create sim/common/device.h */
-/* These are defined with each particular cpu.  */
-int device_io_read_buffer(device *me, void *dest, int space, address_word addr, unsigned nr_bytes, SIM_DESC sd, sim_cpu *processor, sim_cia cia);
-int device_io_write_buffer(device *me, const void *source, int space, address_word addr, unsigned nr_bytes, SIM_DESC sd, sim_cpu *processor, sim_cia cia);
-#endif
-
-
 #endif
diff --git a/sim/common/sim-n-core.h b/sim/common/sim-n-core.h
index 3393f19..0867cc2 100644
--- a/sim/common/sim-n-core.h
+++ b/sim/common/sim-n-core.h
@@ -164,18 +164,6 @@ sim_core_read_aligned_N(sim_cpu *cpu,
   mapping = sim_core_find_mapping (core, map, addr, N, read_transfer, 1 /*abort*/, cpu, cia);
   do
     {
-#if (WITH_DEVICES)
-      if (mapping->device != NULL)
-	{
-	  unsigned_M data;
-	  if (device_io_read_buffer (mapping->device, &data, mapping->space, addr, N, CPU_STATE (cpu), cpu, cia) != N)
-	    sim_engine_abort (CPU_STATE (cpu), cpu, cia,
-			      "internal error - %s - io_read_buffer should not fail",
-			      XSTRING (sim_core_read_aligned_N));
-	  val = T2H_M (data);
-	  break;
-	}
-#endif
 #if (WITH_HW)
       if (mapping->device != NULL)
 	{
@@ -296,17 +284,6 @@ sim_core_write_aligned_N(sim_cpu *cpu,
   mapping = sim_core_find_mapping (core, map, addr, N, write_transfer, 1 /*abort*/, cpu, cia);
   do
     {
-#if (WITH_DEVICES)
-      if (mapping->device != NULL)
-	{
-	  unsigned_M data = H2T_M (val);
-	  if (device_io_write_buffer (mapping->device, &data, mapping->space, addr, N, CPU_STATE (cpu), cpu, cia) != N)
-	    sim_engine_abort (CPU_STATE (cpu), cpu, cia,
-			      "internal error - %s - io_write_buffer should not fail",
-			      XSTRING (sim_core_read_aligned_N));
-	  break;
-	}
-#endif
 #if (WITH_HW)
       if (mapping->device != NULL)
 	{
diff --git a/sim/common/tconfig.h b/sim/common/tconfig.h
deleted file mode 100644
index eaa4832..0000000
--- a/sim/common/tconfig.h
+++ /dev/null
@@ -1,3 +0,0 @@
-/* Default target configuration file.
-   To override this, create file `tconfig.in' in the simulator's
-   source directory.  */
diff --git a/sim/cr16/ChangeLog b/sim/cr16/ChangeLog
index b23e0cb..004d729 100644
--- a/sim/cr16/ChangeLog
+++ b/sim/cr16/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-if.c (cris_option_install): Delete.
diff --git a/sim/cr16/config.in b/sim/cr16/config.in
index 3152bea..fc7af77 100644
diff --git a/sim/cr16/configure b/sim/cr16/configure
index b44e895..676e9a9 100755
diff --git a/sim/cris/ChangeLog b/sim/cris/ChangeLog
index 82cffd3..f2be067 100644
--- a/sim/cris/ChangeLog
+++ b/sim/cris/ChangeLog
@@ -1,5 +1,10 @@
 2015-12-26  Mike Frysinger  <vapier@gentoo.org>
 
+	* config.in, configure: Regenerate.
+	* Makefile.in (rvdummy.o): Delete tconfig.h.
+
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
 	* sim-if.c (sim_open): Delete cpu variable.  Pass NULL/NULL_CIA to
 	sim_core_write_buffer.
 
diff --git a/sim/cris/Makefile.in b/sim/cris/Makefile.in
index a0520ac..887407c 100644
--- a/sim/cris/Makefile.in
+++ b/sim/cris/Makefile.in
@@ -72,7 +72,7 @@ check: rvdummy$(EXEEXT)
 rvdummy$(EXEEXT): rvdummy.o $(EXTRA_LIBDEPS)
 	$(CC) $(ALL_CFLAGS) -o rvdummy$(EXEEXT) rvdummy.o $(EXTRA_LIBS)
 
-rvdummy.o: rvdummy.c config.h tconfig.h $(remote_sim_h) $(callback_h)
+rvdummy.o: rvdummy.c config.h $(remote_sim_h) $(callback_h)
 
 # CRISV10 objs
 
diff --git a/sim/cris/config.in b/sim/cris/config.in
index d2184e6..1734eea 100644
diff --git a/sim/cris/configure b/sim/cris/configure
index 46daa18..eb1e7f4 100755
diff --git a/sim/d10v/ChangeLog b/sim/d10v/ChangeLog
index dd494c1..d51ede7 100644
--- a/sim/d10v/ChangeLog
+++ b/sim/d10v/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-11-15  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_OBJS): Delete sim-reason.o and sim-stop.o.
diff --git a/sim/d10v/config.in b/sim/d10v/config.in
index 3152bea..fc7af77 100644
diff --git a/sim/d10v/configure b/sim/d10v/configure
index 215f0c4..d46ffcb 100755
diff --git a/sim/erc32/ChangeLog b/sim/erc32/ChangeLog
index d3582e6..e9a3241 100644
--- a/sim/erc32/ChangeLog
+++ b/sim/erc32/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-06-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* configure: Regenerate.
diff --git a/sim/erc32/config.in b/sim/erc32/config.in
index 3152bea..fc7af77 100644
diff --git a/sim/erc32/configure b/sim/erc32/configure
index cf91fa9..94c6fa4 100755
diff --git a/sim/frv/ChangeLog b/sim/frv/ChangeLog
index 936bbf2..d61d12c 100644
--- a/sim/frv/ChangeLog
+++ b/sim/frv/ChangeLog
@@ -1,5 +1,9 @@
 2015-12-26  Mike Frysinger  <vapier@gentoo.org>
 
+	* config.in, configure: Regenerate.
+
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
 	* sim-if.c (sim_create_inferior): Replace old #if 0 code with dupargv.
 
 2015-12-25  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/frv/config.in b/sim/frv/config.in
index 99be0a6..0f50442 100644
diff --git a/sim/frv/configure b/sim/frv/configure
index 0cc04c1..ca3363c 100755
diff --git a/sim/ft32/ChangeLog b/sim/ft32/ChangeLog
index b246467..0f3941a 100644
--- a/sim/ft32/ChangeLog
+++ b/sim/ft32/ChangeLog
@@ -1,5 +1,9 @@
 2015-12-26  Mike Frysinger  <vapier@gentoo.org>
 
+	* config.in, configure: Regenerate.
+
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
 	* interp.c (sim_create_inferior): Update comment and argv check.
 
 2015-11-15  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/ft32/config.in b/sim/ft32/config.in
index 3152bea..fc7af77 100644
diff --git a/sim/ft32/configure b/sim/ft32/configure
index 753c3ac..d16b9c5 100755
diff --git a/sim/h8300/ChangeLog b/sim/h8300/ChangeLog
index d566a65..d8f3856 100644
--- a/sim/h8300/ChangeLog
+++ b/sim/h8300/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
 
 	* compile.c (H8300_OPTIONS): New enum from common/sim-options.c.
diff --git a/sim/h8300/config.in b/sim/h8300/config.in
index d64ad48..3abf194 100644
diff --git a/sim/h8300/configure b/sim/h8300/configure
index 0c558e8..3c49020 100755
diff --git a/sim/iq2000/ChangeLog b/sim/iq2000/ChangeLog
index 67529e4..966c27a 100644
--- a/sim/iq2000/ChangeLog
+++ b/sim/iq2000/ChangeLog
@@ -1,5 +1,9 @@
 2015-12-26  Mike Frysinger  <vapier@gentoo.org>
 
+	* config.in, configure: Regenerate.
+
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
 	* sim-if.c (sim_create_inferior): Replace old #if 0 code with dupargv.
 
 2015-12-25  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/iq2000/config.in b/sim/iq2000/config.in
index 99be0a6..0f50442 100644
diff --git a/sim/iq2000/configure b/sim/iq2000/configure
index d2c9629..26937d3 100755
diff --git a/sim/lm32/ChangeLog b/sim/lm32/ChangeLog
index a3da560..68e8d61 100644
--- a/sim/lm32/ChangeLog
+++ b/sim/lm32/ChangeLog
@@ -1,5 +1,9 @@
 2015-12-26  Mike Frysinger  <vapier@gentoo.org>
 
+	* config.in, configure: Regenerate.
+
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
 	* sim-if.c (sim_create_inferior): Replace old #if 0 code with dupargv.
 
 2015-12-25  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/lm32/config.in b/sim/lm32/config.in
index 99be0a6..0f50442 100644
diff --git a/sim/lm32/configure b/sim/lm32/configure
index e5643be..be10750 100755
diff --git a/sim/m32c/ChangeLog b/sim/m32c/ChangeLog
index c44e7eb..19f3114 100644
--- a/sim/m32c/ChangeLog
+++ b/sim/m32c/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-11-09  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (sample.x, sample.mot, sample2.x, sample2.o, gloss.o):
diff --git a/sim/m32c/config.in b/sim/m32c/config.in
index 7d73557..7164bcc 100644
diff --git a/sim/m32c/configure b/sim/m32c/configure
index f51664b..ac41998 100755
diff --git a/sim/m32r/ChangeLog b/sim/m32r/ChangeLog
index c492bd6..ecbf4cf 100644
--- a/sim/m32r/ChangeLog
+++ b/sim/m32r/ChangeLog
@@ -1,5 +1,9 @@
 2015-12-26  Mike Frysinger  <vapier@gentoo.org>
 
+	* config.in, configure: Regenerate.
+
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
 	* sim-if.c (sim_create_inferior): Replace old #if 0 code with dupargv.
 
 2015-12-25  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/m32r/config.in b/sim/m32r/config.in
index 99be0a6..0f50442 100644
diff --git a/sim/m32r/configure b/sim/m32r/configure
index 6b9c76e..5c263da 100755
diff --git a/sim/m68hc11/ChangeLog b/sim/m68hc11/ChangeLog
index 4a20b55..46e243e 100644
--- a/sim/m68hc11/ChangeLog
+++ b/sim/m68hc11/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-main.h (SIM_HANDLES_LMA): Delete.
diff --git a/sim/m68hc11/config.in b/sim/m68hc11/config.in
index 99be0a6..0f50442 100644
diff --git a/sim/m68hc11/configure b/sim/m68hc11/configure
index 5d7749d..6870e8c 100755
diff --git a/sim/mcore/ChangeLog b/sim/mcore/ChangeLog
index d6f0cd1..1d5fa35 100644
--- a/sim/mcore/ChangeLog
+++ b/sim/mcore/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-11-15  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_OBJS): Delete sim-reason.o, sim-reg.o, and
diff --git a/sim/mcore/config.in b/sim/mcore/config.in
index 3152bea..fc7af77 100644
diff --git a/sim/mcore/configure b/sim/mcore/configure
index 215f0c4..d46ffcb 100755
diff --git a/sim/microblaze/ChangeLog b/sim/microblaze/ChangeLog
index 5712f28..ed97275 100644
--- a/sim/microblaze/ChangeLog
+++ b/sim/microblaze/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-11-15  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_OBJS): Delete sim-reason.o and sim-stop.o.
diff --git a/sim/microblaze/config.in b/sim/microblaze/config.in
index 3152bea..fc7af77 100644
diff --git a/sim/microblaze/configure b/sim/microblaze/configure
index 215f0c4..d46ffcb 100755
diff --git a/sim/mips/ChangeLog b/sim/mips/ChangeLog
index eb076e4..7d7725d 100644
--- a/sim/mips/ChangeLog
+++ b/sim/mips/ChangeLog
@@ -1,5 +1,9 @@
 2015-12-26  Mike Frysinger  <vapier@gentoo.org>
 
+	* config.in, configure: Regenerate.
+
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
 	* interp.c (sim_write, sim_read): Delete.
 	(store_word): Delete call to AddressTranslation and set paddr=vaddr.
 	(load_word): Likewise.
diff --git a/sim/mips/config.in b/sim/mips/config.in
index e6e3dc3..70bf5ca 100644
diff --git a/sim/mips/configure b/sim/mips/configure
index e1a838d..6f1d136 100755
diff --git a/sim/mn10300/ChangeLog b/sim/mn10300/ChangeLog
index bce1772..65fa03e 100644
--- a/sim/mn10300/ChangeLog
+++ b/sim/mn10300/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-main.h (SIM_HANDLES_LMA): Delete.
diff --git a/sim/mn10300/config.in b/sim/mn10300/config.in
index e4603ad..664dc35 100644
diff --git a/sim/mn10300/configure b/sim/mn10300/configure
index 703063f..6e4246e 100755
diff --git a/sim/moxie/ChangeLog b/sim/moxie/ChangeLog
index 40fa592..016c61f 100644
--- a/sim/moxie/ChangeLog
+++ b/sim/moxie/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-11-15  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_OBJS): Delete sim-reason.o and sim-stop.o.
diff --git a/sim/moxie/config.in b/sim/moxie/config.in
index 3152bea..fc7af77 100644
diff --git a/sim/moxie/configure b/sim/moxie/configure
index 53bc48b..3232de3 100755
diff --git a/sim/msp430/ChangeLog b/sim/msp430/ChangeLog
index 53fece0..0d57e7f 100644
--- a/sim/msp430/ChangeLog
+++ b/sim/msp430/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-12-15  Dominik Vogt  <vogt@linux.vnet.ibm.com>
 
 	* msp430-sim.c (get_op, put_op): Fix left shift of negative value.
diff --git a/sim/msp430/config.in b/sim/msp430/config.in
index 531fe19..a52fc2b 100644
diff --git a/sim/msp430/configure b/sim/msp430/configure
index b5d166c..796741b 100755
diff --git a/sim/ppc/ChangeLog b/sim/ppc/ChangeLog
index 9d85c4c..413a99d 100644
--- a/sim/ppc/ChangeLog
+++ b/sim/ppc/ChangeLog
@@ -1,3 +1,9 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (TCONFIG_H): Delete.
+	(sim-fpu.o): Delete $(TCONFIG_H).
+	(tconfig.h): Delete rule.
+
 2015-11-21  Mike Frysinger  <vapier@gentoo.org>
 
 	PR sim/13834
diff --git a/sim/ppc/Makefile.in b/sim/ppc/Makefile.in
index bac36a9..5f68909 100644
--- a/sim/ppc/Makefile.in
+++ b/sim/ppc/Makefile.in
@@ -446,9 +446,6 @@ SUPPORT_H = \
 TARG_VALS_H = \
         targ-vals.h
 
-TCONFIG_H = \
-        tconfig.h
-
 INLINE = \
 	inline.h \
 	inline.c
@@ -659,13 +656,9 @@ callback.o: $(srcdir)/../common/callback.c $(TARG_VALS_H) $(CONFIG_H)
 
 targ-map.o: targ-map.c $(ANSIDECL_H) $(GDB_CALLBACK_H) $(TARG_VALS_H)
 
-sim-fpu.o: $(srcdir)/../common/sim-fpu.c $(CONFIG_H) $(TCONFIG_H)
+sim-fpu.o: $(srcdir)/../common/sim-fpu.c $(CONFIG_H)
 	$(CC) -c $(STD_CFLAGS) -DHAVE_CONFIG_H $(srcdir)/../common/sim-fpu.c 
 
-tconfig.h:
-	rm -f tconfig.h
-	echo > tconfig.h
-
 # Rebuild options whenever something changes so the date/time is up to date.
 options.o: options.c $(CPU_H) $(OPTIONS_H) $(DEFINES_H) $(BASICS_H) $(IDECODE_H) $(INLINE) $(LIB_SRC) $(BUILT_SRC) config.status Makefile
 	$(CC) -c $(STD_CFLAGS) '-DOPCODE_RULES="@sim_opcode@"' '-DIGEN_FLAGS="$(IGEN_FLAGS)"' '-DDGEN_FLAGS="$(DGEN_FLAGS)"' $(srcdir)/options.c
diff --git a/sim/rl78/ChangeLog b/sim/rl78/ChangeLog
index d9d3817..5a15461 100644
--- a/sim/rl78/ChangeLog
+++ b/sim/rl78/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-06-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* configure: Regenerate.
diff --git a/sim/rl78/config.in b/sim/rl78/config.in
index 531fe19..a52fc2b 100644
diff --git a/sim/rl78/configure b/sim/rl78/configure
index 433cad3..6b45e05 100755
diff --git a/sim/rx/ChangeLog b/sim/rx/ChangeLog
index 15bc12f..43c715c 100644
--- a/sim/rx/ChangeLog
+++ b/sim/rx/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-11-10  Nick Clifton  <nickc@redhat.com>
 
 	* rx.c (id_names): Add nop4, nop5, nop6 and nop7.
diff --git a/sim/rx/config.in b/sim/rx/config.in
index 077a1e8..236f6a4 100644
diff --git a/sim/rx/configure b/sim/rx/configure
index e36b80d..4bd0e58 100755
diff --git a/sim/sh/ChangeLog b/sim/sh/ChangeLog
index 427333d..b744ac2 100644
--- a/sim/sh/ChangeLog
+++ b/sim/sh/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-11-21  Mike Frysinger  <vapier@gentoo.org>
 
 	* gencode.c (tab): Pass sd into trap calls.
diff --git a/sim/sh/config.in b/sim/sh/config.in
index 3152bea..fc7af77 100644
diff --git a/sim/sh/configure b/sim/sh/configure
index 215f0c4..d46ffcb 100755
diff --git a/sim/sh64/ChangeLog b/sim/sh64/ChangeLog
index 8a2b58b..7fc3982 100644
--- a/sim/sh64/ChangeLog
+++ b/sim/sh64/ChangeLog
@@ -1,5 +1,9 @@
 2015-12-26  Mike Frysinger  <vapier@gentoo.org>
 
+	* config.in, configure: Regenerate.
+
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
 	* sim-if.c (sim_create_inferior): Replace old #if 0 code with dupargv.
 
 2015-12-25  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/sh64/config.in b/sim/sh64/config.in
index 99be0a6..0f50442 100644
diff --git a/sim/sh64/configure b/sim/sh64/configure
index 2a3e660..6310f42 100755
diff --git a/sim/v850/ChangeLog b/sim/v850/ChangeLog
index 82652f0..14fe2eb 100644
--- a/sim/v850/ChangeLog
+++ b/sim/v850/ChangeLog
@@ -1,3 +1,7 @@
+2015-12-26  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-12-24  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-main.h (WITH_WATCHPOINTS): Delete.